/* dials from Animated_dial 09/02/2021 modified by msport  no jpg
 * and to integrate Dave Bodnar Throttle hz version
 *  a sprite may be referenced to tft or to an another sprite
 *  12 02 20  *  from dials_16
 *  for ESP_PAD_22 pcb
 * https://www.aranacorp.com/en/using-the-eeprom-with-the-esp32/
 See example which draws an animated dial with a rotating needle.
 * Created by Bodmer 17/3/20 as an example to the TFT_eSPI library:
 * https: *github.com/Bodmer/TFT_eSPI

  ##################################################################################
  ###### DON'T FORGET TO UPDATE THE User_Setup.h FILE IN THE TFT_eSPI LIBRARY ######
  ######                FOR YOUR FIDPLAY MODEL AND PINOUT                     ######
  ##################################################################################
  6152_polar45 pour turntable
*/

#include<EEPROM.h>
#define EEPROM_SIZE 32
#define EEPROM_ADDRESS 16
// Color definitions
#define BLACK   0x0000
#define BLUE    0x001F
#define RED     0xF800
#define GREEN   0x07E0
#define CYAN    0x07FF
#define MAGENTA 0xF81F
#define YELLOW  0xFFE0  
#define WHITE   0xFFFF
#define TFT_GREY 0x5AEB

String V_Date = "06 09 2022";
String version = "0.18 ";

char text[17];
char key ; // uint8_t key;
int Key;
int debug = 0;

#include <ESP32Encoder.h> // https://www.arduinolibraries.info/libraries/esp32-encoder
ESP32Encoder encoder2;

// const int batPin =  33;      // battery sur pcb pad_22
const int tempPin =  5;      // CTN sur pcb pad_22
int buttonPin = 26; // button on rotary
int positionSpeed; // keep encoder position for speed
int positionPoint; // keep encoder position for Point numberTurntable
int positionTurntable; // keep encoder position for Turntable
int positionAccessory; // keep encoder position for Accessory number
int buttonState = 0;
int encoderChange = 0; // flag to show encoder changed
boolean AccessoryDone = false;
int PointAddressDble = 2;
int PointAddress = 1;
int AccessoryAddressDble = 2;
int AccessoryAddress = 1;
int TurntableAddressDble = 2;
int TurntableAddress = 1;
int xxxxx = 0;
int counter = 0; 
#define NEEDLE_LENGTH 35  // Visible length
#define NEEDLE_WIDTH   5  // Width of needle - make it an odd number
#define NEEDLE_RADIUS 90  // Radius at tip
#define NEEDLE_COLOR1 TFT_MAROON  // Needle periphery colour
#define NEEDLE_COLOR2 TFT_RED     // Needle centre colour
#define DIAL_CENTRE_X 120
#define DIAL_CENTRE_Y 120
#define DIAL_CENTRE_2_X 120 // 360
#define DIAL_CENTRE_2_Y 120 // 200
#define BUTTON_CORNER_X 280 // 260
#define BUTTON_CORNER_Y 260   // 60
#define BUTTON_CORNER_2_X 60  //  20
#define BUTTON_CORNER_2_Y 260 // 300
#define BUTTON_FIRST_RAW_X 460 // 20 modif
#define BUTTON_FIRST_RAW_Y 220 // 260
#define BUTTON_FIRST_RAW_2_X  20 // 220
#define BUTTON_FIRST_RAW_2_Y 220 // 20

#include "turntable.h"

#include <TFT_eSPI.h>
#include <SPI.h>
// TFT_eSPI tft = TFT_eSPI();  // Invoke custom library, pins defined in User_Setup.h
TFT_eSprite dial = TFT_eSprite(&tft); // Sprite object for needle
TFT_eSprite needle = TFT_eSprite(&dial); // Sprite object for needle // &TFT
TFT_eSprite spr    = TFT_eSprite(&tft); // Sprite for meter reading

uint16_t* tft_buffer;
bool      buffer_loaded = false;
uint16_t  spr_width = 0;

byte commandGroup = 0;
bool Ok = false;
byte Fx = 0;
String byte1 = " 222";
// 2nd Array set for 4 Loco Left side  - change the 7 numbers in the next 7 declarations
int maxLocos_2 = 4; // number of loco addresses
int LocoAddress_2[4] = {8, 18, 68, 15};
int LocoDirection_2[4] = {1, 1, 1, 1};
int LocoSpeed_2[4] = {0, 0, 0, 0};
byte LocoFN_2[4][4]= {{0, 0, 0, 0},{0, 0, 0, 0},{0, 0, 0, 0},{0, 0, 0, 0}} ; // [LIGNES][COLONNES] for 13-20 and 21-28 2&3 groups / loco addresses
byte LocoFN0to4_2[4]= {0, 0, 0, 0}; // 0 group
byte LocoFN5to8_2[4]= {0, 0, 0, 0}; // 0 group
byte LocoFN9to12_2[4]= {0, 0, 0, 0}; // 1 group
byte LocoFN13to20_2[4]= {0, 0, 0, 0}; // 2 group
byte LocoFN21to28_2[4]= {0, 0, 0, 0}; // 3 group
byte group_2[4]= {0, 0, 0, 0}; // 
int delta_2[4] = {0,4,12,20};
int ZeroSpeedFlag = 0;
int ActiveAddress_2 = 0; // make address_2_1 active

#include <Keypad.h>
const byte ROWS = 4; //four rows
const byte COLS = 4; //four columns
char keys[ROWS][COLS] = {
  {'1', '2', '3', 'A'},
  {'4', '5', '6', 'B'},
  {'7', '8', '9', 'C'},
  {'*', '0', '#', 'D'}
};
byte rowPins[ROWS] = {19, 18, 17, 25}; // 25, 17, 18, 19 //connect to the row pinouts of the keypad
byte colPins[COLS] = {21, 22, 23, 27}; //  //connect to the column pinouts of the keypad
Keypad keypad = Keypad( makeKeymap(keys), rowPins, colPins, ROWS, COLS );
unsigned long previousMillis = 0;        // during setup
unsigned long delayed = 4000 ;           // during setup

int16_t angle2 = -1;

bool sens2 = true;
bool lastIsBusy = false;
bool isBusy = false;

bool buttonsRefresh2 = false;

bool tftRefresh2 = false;

String forward = ">>>";
String backwards = "<<<";  
String arrow2 = ">>>";

int buttonPin2 = 26 ; // button on rotary esp32 e-pad-22 

int V_Pin = 33 ;
float voltage = 3.7 ;

// Include the Bounce2 library found here : https://github.com/thomasfredericks/Bounce2
#include <Bounce2.h>
Bounce debouncer1 = Bounce(); // Instantiate  Bounce objects

void getAddresses() { // get Addresses in EEPROM
  EEPROM.begin(EEPROM_SIZE);
  int addresse = EEPROM_ADDRESS;
  int readId;
  readId = EEPROM.read(addresse); //EEPROM.get(address,readId);
  LocoAddress_2[0] = readId ;
  addresse += sizeof(readId); //update address value
  readId = EEPROM.read(addresse); //EEPROM.get(address,readId);
  LocoAddress_2[1] = readId ;
  addresse += sizeof(readId); //update address value
  readId = EEPROM.read(addresse); //EEPROM.get(address,readId);
  LocoAddress_2[2] = readId ;
  addresse += sizeof(readId); //update address value
  readId = EEPROM.read(addresse); //EEPROM.get(address,readId);
  LocoAddress_2[3] = readId ;
  EEPROM.end();
}   // END getAddresses

void saveAddresses() { // save Addresses to EEPROM
  EEPROM.begin(EEPROM_SIZE);  //Write data into eeprom
  int addresse = EEPROM_ADDRESS;
  int boardId1 = LocoAddress_2[0];
  EEPROM.write(addresse, boardId1);
  addresse += sizeof(boardId1); //update address value
  int boardId2 = LocoAddress_2[1];
  EEPROM.write(addresse, boardId2);
  addresse += sizeof(boardId2); //update address value
  int boardId3 = LocoAddress_2[2];
  EEPROM.write(addresse, boardId3);
  addresse += sizeof(boardId3); //update address value
  int boardId4 = LocoAddress_2[3];
  EEPROM.write(addresse, boardId4);
  boolean res = EEPROM.commit();
}   // END saveAddresses

void getLocoAddress() { // getLocoAddress from keyboard
  int saveAddress =   LocoAddress_2[ActiveAddress_2];
  Serial.print("<0>");// power off to DCC++ unit
  int total = 0;
  int counter = 0;
  tft.setTextColor(TFT_YELLOW,TFT_BLACK); // tft.setCursor(210, 200);
  tft.setCursor(92, 88); // chg no loco
  do {                                      //  collect exactly 4 digits
    key = keypad.getKey();
    if (key == '#' || key == '*') { //abort when either is hit
      //LocoAddress_2[ActiveAddress] = saveAddress;
      total = saveAddress;
      break;  // exit routine if # button pressed - ABORT new address
    }
    if (key) {
      counter++;
      int number =  key - 48;
      total = total * 10 + number;
      tft.setCursor(92, 88); // 
      if (total == 0) {
        for (int tempx = 0; tempx < counter; tempx++) {
          tft.print("0"); // print multiple zeros for leading zero number
        }
      }
      else {
        tft.print(total);
      }
    }
  } while (counter <= 3); //  collect exactly 4 digits
  LocoAddress_2[ActiveAddress_2] = total;

  saveAddresses();
  
  delay (1000);
  tftRefresh2 = true;
  RefreshAllButtons_2() ;
}   // END getLocoAddress
 
void all2ZeroSpeeed() {  // set flag to 1 to stop, set to 0 to restore
  for (int tempx = 0; tempx <= maxLocos_2; tempx++) {
    Serial.print("<t1 ");
    Serial.print(LocoAddress_2[tempx] );//locoID);
    Serial.print(" ");
    if (ZeroSpeedFlag == 1) {
      Serial.print(0);//LocoSpeed[0] );
    }
    else Serial.print(LocoSpeed_2[0] );
    Serial.print(" ");
    Serial.print(LocoDirection_2[1] );
    Serial.write(">");
  }
}

void getNumberOfLocos() {  // initial choice of loco number to cycle in
  tft.fillScreen(TFT_BLACK);  // clears the screen and buffer 
  tft.setCursor(0, 20);
  tft.setTextColor(TFT_WHITE);
  tft.println("Choisissez ");
  tft.println("le nombre de locos ");  tft.println(F("au clavier :")); tft.print(F("  ")); 
  tft.setTextColor(TFT_CYAN); tft.print(maxLocos_2);
  tft.println("");
  tft.setTextColor(TFT_WHITE);
  tft.println(F("Nouvelle valeur")); 
  tft.println(F(" 1-4 : ")); 
 
  tft.setTextColor(TFT_CYAN);
  do {
    key = keypad.getKey();
    key = key - 48; // convert from ascii value
    tft.setCursor(55, 150);   
    tft.println(key);
    if (key == 1 || key == 2 || key == 3 || key == 4) { // 1-4
      tft.setCursor(55, 150);      
      maxLocos_2 = key ; // + 1;
      tft.print(maxLocos_2);
      Ok = true;
    }
  } while ( ! Ok );
  delay(1000); 
}  // END getNumberOfLocos

// =======================================================================================
// This function will be called during setup
// =======================================================================================
void drawButtons(int centerX, int centerY){
  for (int j=0; j<3; j++){
    for (int i=0; i<8; i++){
      tft.fillCircle(centerX + 20*i, centerY + 20*j, NEEDLE_LENGTH /4 , TFT_DARKGREY); //0
      tft.fillCircle(centerX + 20*i, centerY + 20*j, NEEDLE_LENGTH /5 , TFT_MAROON); 
    }
  }  
} 
// =======================================================================================
// This function will be called within loop
// =======================================================================================
void updateButtons(int centerX, int centerY, int j, int i, int colour){
      tft.fillCircle(centerX + 20*i, centerY + 20*j, NEEDLE_LENGTH /5 , colour); 
}  

// =======================================================================================
// This function will be called during setup
// =======================================================================================
void drawFirstButtons(int centerX, int centerY){
  for (int i=0; i<5; i++){
    tft.fillCircle(centerX, centerY + 20*i, NEEDLE_LENGTH /4 , TFT_DARKGREY); //0
    tft.fillCircle(centerX, centerY + 20*i, NEEDLE_LENGTH /5 , TFT_MAROON); //0
  }
}  
// =======================================================================================
// This function will be called within loop
// =======================================================================================
void updateFirstButtons(int centerX, int centerY, int i, int colour){
    tft.fillCircle(centerX, centerY + 20*i, NEEDLE_LENGTH /5 , colour); 
}     
// =======================================================================================
// This function will be called during setup draw Dial 
// =======================================================================================
void drawEmptyDial(String label, int16_t val, String way) { // int centerX, int centerY
  // Create the dial Sprite
  dial.setColorDepth(8);       // Size is odd (i.e. 91) so there is a centre pixel at 45,45
  dial.createSprite(240, 240);   // 8bpp requires 91 * 91 = 8281 bytes
  dial.setPivot(120, 120);       // set pivot in middle of dial Sprite
  dial.fillSprite(TFT_TRANSPARENT);           // Fill with transparent colour
  dial.fillCircle(120, 120, NEEDLE_LENGTH * 3.4 , TFT_WHITE); //0
  dial.fillCircle(120, 120, (NEEDLE_LENGTH * 3.4) - 1 , TFT_DARKGREY); //0
  dial.fillCircle(120, 120, NEEDLE_LENGTH * 3.1 , TFT_BLACK); //3
  dial.drawCircle(120, 120, NEEDLE_RADIUS-NEEDLE_LENGTH, TFT_WHITE); //radius ->NEEDLE_LENGTH radius-int ->NEEDLE_RADIUS
  double angle = 1.83; // 0.262 ;  // 0.0655
  for (int i=0; i<11;  i++ ){ // long spines - should be 12, see last one at end
    dial.drawLine(120 + (NEEDLE_RADIUS * 0.92)* cos(angle), 120 + (NEEDLE_RADIUS * 0.92)* sin(angle), 120 + NEEDLE_RADIUS * 1.2 * cos(angle), 120 + NEEDLE_RADIUS * 1.2 * sin(angle), TFT_WHITE); // 12 secteurs
    for (int j=0; j<4;  j++ ){ // short spines - see last four ones at end
      angle = angle + 0.105 ;// + 0.131 ; //     
      dial.drawLine(120 + (NEEDLE_RADIUS * 1.1)* cos(angle), 120 + (NEEDLE_RADIUS * 1.1)* sin(angle), 120 + NEEDLE_RADIUS * 1.2 * cos(angle), 120 + NEEDLE_RADIUS * 1.2 * sin(angle), TFT_WHITE); // 12 secteurs
    }
     angle = angle + 0.105 ;// 
  }
  dial.drawLine(120 + (NEEDLE_RADIUS * 0.92)* cos(angle), 120 + (NEEDLE_RADIUS * 0.92)* sin(angle), 120 + NEEDLE_RADIUS * 1.2 * cos(angle), 120 + NEEDLE_RADIUS * 1.2 * sin(angle), TFT_WHITE); // 12 secteurs
  angle = 1.3;
  for (int k=0; k<12;  k++ ){ // draw numbers around the dial
    angle = angle + 0.523 ;// + 0.131 ; //     
      tft.setTextFont(4); 
//      dial.setTextSize(1);
    dial.setTextColor(TFT_WHITE);
    dial.drawNumber(10*k, 120  + ((NEEDLE_RADIUS * 0.85)- 4) * cos(angle), 120 + ((NEEDLE_RADIUS * 0.85)) * sin(angle)); //-5 -10 ajoutés
//    dial.drawNumber(10*k, 120 - 5 + ((NEEDLE_RADIUS * 0.85)- 4) * cos(angle), 120 + ((NEEDLE_RADIUS * 0.85)- 4) * sin(angle)); //-5 -10 ajoutés
//    dial.drawNumber(100, DIAL_CENTRE_2_X, DIAL_CENTRE_2_Y, 4);
  } // end for
  dial.setTextSize(2);
  dial.setTextColor(TFT_YELLOW);
  dial.setTextDatum(TC_DATUM);              // Draw dial text
  dial.drawString(label, 120, 82, 2); // x, y 
  dial.setTextColor(TFT_WHITE);
  dial.drawNumber(val, 120, 110, 2);
  dial.setTextColor(TFT_GREEN);
  dial.setTextSize(2);
  dial.drawString(way, 120, 140, 2);  
}  // END drawDial 

// =======================================================================================
// Create the needle Sprite 1
// =======================================================================================
void createNeedle(void) {
  needle.setColorDepth(16);
  needle.createSprite(NEEDLE_WIDTH, NEEDLE_LENGTH);  // create the needle Sprite
  needle.fillSprite(TFT_BLACK); // Fill with black
  // Define needle pivot point relative to top left corner of Sprite
  uint16_t piv_x = NEEDLE_WIDTH / 2; // pivot x in Sprite (middle)
  uint16_t piv_y = NEEDLE_RADIUS;    // pivot y in Sprite
  needle.setPivot(piv_x, piv_y);     // Set pivot point in this Sprite
  // Draw the red needle in the Sprite
  needle.fillRect(0, 0, NEEDLE_WIDTH, NEEDLE_LENGTH, TFT_MAROON);
  needle.fillRect(1, 1, NEEDLE_WIDTH-2, NEEDLE_LENGTH-2, TFT_RED);
  // Bounding box parameters to be populated
  int16_t min_x;  int16_t min_y;  int16_t max_x;  int16_t max_y;
  // Work out the worst case area that must be grabbed from the TFT,
  // this is at a 45 degree rotation
  needle.getRotatedBounds(45, &min_x, &min_y, &max_x, &max_y);
  // Calculate the size and allocate the buffer for the grabbed TFT area
  tft_buffer =  (uint16_t*) malloc( ((max_x - min_x) + 2) * ((max_y - min_y) + 2) * 2 );
} // END createNeedle 1


// =======================================================================================
// Move the needle 1 to a new position
// =======================================================================================
void plotNeedle(int16_t angle, uint16_t ms_delay) {
  static int16_t old_angle = -165; // Starts at -120 degrees +15 / vertical
  // Bounding box parameters
  static int16_t min_x;  static int16_t min_y;  static int16_t max_x;  static int16_t max_y;
  if (angle < 0) angle = 0; // Limit angle to emulate needle end stops
  if (angle > 354) angle = 345; // 240;
  angle -= 165; // Starts at -45, one 1/12 is missing (/2) / -120 degrees ? 
  // Move the needle until new angle reached
  while (angle != old_angle || !buffer_loaded) {
    if (old_angle < angle) old_angle++;
    else old_angle--;
    // Only plot needle at even values to improve plotting performance
    if ( (old_angle & 1) == 0) {
      if (buffer_loaded) {
        // Paste back the original needle free image area
        tft.pushRect(min_x, min_y, 1 + max_x - min_x, 1 + max_y - min_y, tft_buffer);
      }
      if ( needle.getRotatedBounds(old_angle, &min_x, &min_y, &max_x, &max_y) ) {
        // Grab a copy of the area before needle is drawn
        tft.readRect(min_x, min_y, 1 + max_x - min_x, 1 + max_y - min_y, tft_buffer);
        buffer_loaded = true;
      }
      // Draw the needle in the new postion, black in needle image is transparent
      needle.pushRotated(old_angle, TFT_BLACK);
      // Wait before next update
      delay(ms_delay);
    }
    // Update the number at the centre of the dial
    spr.drawNumber((old_angle+165)/3, spr_width/2, spr.fontHeight()/2); // 120
    spr.pushSprite(120 - spr_width / 2, 120 - spr.fontHeight() / 2);
    // Slow needle down slightly as it approaches the new position
    if (abs(old_angle - angle) < 10) ms_delay += ms_delay / 5;
  }
} // END plotNeedle 1

void doDCC_2(int Address) {
  Serial.print("<t1 ");
  Serial.print(LocoAddress_2[Address] );//locoID);
  Serial.print(" ");
  Serial.print(LocoSpeed_2[Address] );
  Serial.print(" ");
  Serial.print(LocoDirection_2[Address] );
  Serial.println(">");
}  // END doDCC left

void doDCCfunction(int Address, String Byte1, int fx) {
  Serial.write("<f ");
  Serial.print(Address);
  Serial.print(Byte1);
  Serial.print(" ");
  Serial.print(fx);
  Serial.print(">");
}  // END doDCCfunction


void all2ZeroSpeed() {  // set flag to 1 to stop, set to 0 to restore
  for (int i = 0; i <= maxLocos_2; i++) {
    Serial.print("<t1 ");
    Serial.print(LocoAddress_2[i] );//locoID);
    Serial.print(" ");
    if (ZeroSpeedFlag == 1) {
      Serial.print(0);  
    }
    else Serial.print(LocoSpeed_2[0] );
    Serial.print(" ");
    Serial.print(LocoDirection_2[0] );
    Serial.write(">");
  }
}  // END all2ZeroSpeed

void doTurnTable(){   // letter C  key == 67
  tft.setTextSize(1);    tft.fillScreen(TFT_TRANSPARENT);  // clears the screen and buffer 
  tft.setTextColor(TFT_YELLOW,TFT_TRANSPARENT);
  tft.setCursor(0,10); // doDCCaccessory
  tft.print("  Pont  tournant  ");
  tft.setTextColor(GREEN);   tft.println("6152  "); 
  encoder2.setCount( numPos ) ;
  drawPlaque();  
  calculePont(&lepont, numPos);
  drawPont (&lepont, numPos);
  tft.setCursor(60, 285); tft.setTextSize(1);  tft.setTextColor(GREEN, TFT_TRANSPARENT); tft.print(">");
  do  {
   key = keypad.getKey();
   Key = key - 30;
    if ( encoder2.getCount() < 0) encoder2.setCount( 192 ) ;  // 0 47
    if ( encoder2.getCount() > 192) encoder2.setCount( 0 ) ;
    versPos = ( encoder2.getCount() ) / 4  ;
//    versPos = ( encoder2.getCount() - 1 ) / 4  ;
    if ( versPos != oldPos) { textTurnTable() ; oldPos = versPos ; }
    // versPos = versPos / 2 + 1 ;
    
    debouncer1.update(); // codeur
    if ( debouncer1.fell() ) {
      tft.setTextColor(TFT_RED, TFT_TRANSPARENT);  
      tft.setCursor(180, 285);
//      tft.println("Ok");
//      tft.println("COMMANDE");
      ordreEnCours = 1;  
      tft.setCursor(20, 285);
      tft.printf("%02d", versPos);
      displayToPosition( numPos, versPos); 
      doDCCTurnTable(depuisPos, versPos) ;
      depuisPos = versPos;
    }   
  } while (Key != 37) ; // C TurnTable
  positionTurntable = 0; // keep encoder position for Turntable
  encoder2.setCount( LocoSpeed_2[ActiveAddress_2]*3 );
  tft.init();
  tft.setTextFont(4);
  tft.fillScreen(TFT_TRANSPARENT);
  tftRefresh2 = true;
  drawFirstButtons(BUTTON_FIRST_RAW_2_X, BUTTON_FIRST_RAW_2_Y);
  drawButtons(BUTTON_CORNER_2_X, BUTTON_CORNER_2_Y);
  RefreshAllButtons_2() ;
  } //  END doTurnTable

void textTurnTable() {
//      tft.setCursor(180, 285); tft.setTextSize(1);  tft.setTextColor(TFT_RED, TFT_TRANSPARENT); tft.println("Ok ");
      displayToPosition( numPos, versPos); 
      oldVersPos = versPos;
      tft.setCursor(20, 285); tft.setTextSize(1);  tft.setTextColor(TFT_YELLOW, TFT_TRANSPARENT);  // tft.print("----");
      tft.printf("%02d", depuisPos);
      tft.setCursor(80, 285); tft.setTextSize(1);  tft.setTextColor(GREEN, TFT_TRANSPARENT);
      tft.printf("%02d", versPos);    
}

void doDCCTurnTable(int from, int getTo) {  // fixed on one address, solenoid to be triggered by decoder
  Serial.print ("<a ");                     // desactivate from address
  Serial.print ((( from + 99 ) / 4) + 1 );  //  Track Address, DCC++ works with address + sub address
  Serial.print (" ");
  Serial.print (( from + 99 ) % 4 );        //  Track Sub Address 
  Serial.println (" 0>");

  Serial.print ("<a ");                     //  activate getTo address
  Serial.print ((( getTo + 99 ) / 4) + 1 ); //  Track Address, DCC++ works with address + sub address
  Serial.print (" ");
  Serial.print (( getTo + 99 ) % 4 );       //  Track Sub Address 
  Serial.println (" 1>");

} //  END doDCCTurnTable

void doPoints(){        // key == 66 letter B
  tft.init();
  tft.setTextFont(4);
  tft.fillScreen(TFT_TRANSPARENT);  // clears the screen and buffer 
  tft.setTextColor(TFT_YELLOW,TFT_TRANSPARENT);
  tft.setCursor(50,10); // doDCCPoint
  tft.println("Aiguillages ");
  do {
    if ( encoder2.getCount() < 1) encoder2.setCount( 1 ) ;
    if ( encoder2.getCount() > 512) encoder2.setCount( 512 ) ;
    PointAddressDble = ( encoder2.getCount() - 1 ) / 4  ;
    PointAddress = PointAddressDble / 2 + 1 ;
    tft.setCursor(70,50); // 
    tft.print(" A = ");
    tft.print( PointAddress, DEC); 
    tft.print("     ");
    tft.setCursor(20, 80); // line 2
    tft.print(((PointAddress - 1) / 4) + 1, DEC ); // main address
    tft.print(" / ");  
    tft.print(((PointAddress -1) % 4 ), DEC );  // sub address
    tft.print("   ");    
    tft.setCursor(96, 80); // before last character line 2
    tft.print(" Ad / Sub Ad");
    tft.setCursor(0, 120); // start of 3rd line
    tft.print(" Appuyer pour    ");   
    tft.setCursor(0, 160); // start of 4th line 
    if (PointAddressDble % 2 == 0 ) {
      tft.setTextColor(GREEN, TFT_TRANSPARENT);
      tft.print("  Devier     ");
      tft.setTextColor(WHITE, TFT_TRANSPARENT);
    }
    else {
      tft.setTextColor(YELLOW, TFT_TRANSPARENT);
      tft.print("  Direct         ");
      tft.setTextColor(WHITE, TFT_TRANSPARENT);
    }
    debouncer1.update();
    if ( debouncer1.fell() ) {
      tft.setCursor(0, 190);
      tft.setTextColor(TFT_RED, TFT_TRANSPARENT);  
      tft.println("COMMANDE");
      doDCCPoint() ;
    }   
    key = keypad.getKey();   
  } while (key != 66); // B
  positionPoint = 0 ; // keep encoder position for Point numberTurntable
  encoder2.setCount( LocoSpeed_2[ActiveAddress_2]*3 );
  tftRefresh2 = true;
  tft.fillScreen(TFT_TRANSPARENT);
  drawButtons(BUTTON_CORNER_2_X, BUTTON_CORNER_2_Y);
  drawFirstButtons(BUTTON_FIRST_RAW_2_X, BUTTON_FIRST_RAW_2_Y);
  RefreshAllButtons_2() ;
}  //  END doPoints

void doDCCPoint() { 
  Serial.print ("<a ");
  Serial.print ((( PointAddress - 1 ) / 4) + 1 ); // Point Address, DCC++ works with address + sub address
  Serial.print (" ");
  Serial.print (( PointAddress - 1 ) % 4 );  // Point Sub Address 
  if (PointAddressDble % 2 == 0 ) {      
    Serial.println (" 1 >");
  }
  else {
    Serial.println (" 0 >");
  }
} //  END doDCCPoint

void doAccessories(){  // key == 65 letter A
  tft.fillScreen(TFT_TRANSPARENT);  // clears the screen and buffer 
  tft.setTextColor(TFT_YELLOW,TFT_TRANSPARENT);
  tft.setTextFont(4); 
  tft.setCursor(50,10);
  tft.println("Accessoires ");
  //  tft.print( AccessoryAddress - (( AccessoryAddress - 1) % 2), DEC); 
  encoder2.setCount( AccessoryAddress );
  do {
    if ( encoder2.getCount() < 1) encoder2.setCount( 1 ) ;
    if ( encoder2.getCount() > 1024) encoder2.setCount( 1024 ) ;
    AccessoryAddressDble = ( encoder2.getCount() - 1 ) / 4  ;
    AccessoryAddress = AccessoryAddressDble / 2 + 1 ;
    tft.setCursor(70,50); // 
    tft.print(" A = ");
//    tft.print( AccessoryAddress - (( AccessoryAddress - 1) % 2), DEC); 
    tft.print(  AccessoryAddress, DEC); 
    tft.print("     ");
    tft.setCursor(20, 80); // line 2
    tft.print(((AccessoryAddress - 1) / 4) + 1, DEC ); // main address
    tft.print(" / ");  
    tft.print(((AccessoryAddress -1) % 4 ), DEC );  // sub address
    tft.print("   ");    
    tft.setCursor(96, 80); // before last character line 2
    tft.print(" Ad / Sub Ad");
    tft.setCursor(0, 120); // start of 3rd line
    tft.print(" Appuyer pour    ");   
    tft.setCursor(0, 160); // start of 4th line 
    if (AccessoryAddressDble % 2 == 0 ) {
      tft.setTextColor(GREEN, TFT_TRANSPARENT);
      tft.print("  Desactiver     ");
      tft.setTextColor(WHITE, TFT_TRANSPARENT);
    }
    else {
      tft.setTextColor(YELLOW, TFT_TRANSPARENT);
      tft.print("  Activer         ");
      tft.setTextColor(WHITE, TFT_TRANSPARENT);
    }
    debouncer1.update();
    if ( debouncer1.fell() ) {
      tft.setCursor(0, 190);
      tft.setTextColor(TFT_RED, TFT_TRANSPARENT);  
      tft.println("COMMANDE");
      doDCCaccessory() ;
    }   
    key = keypad.getKey();
  }       while (key != 65);  // A
  positionAccessory = AccessoryAddress;
  encoder2.setCount( LocoSpeed_2[ActiveAddress_2]*3 );
  tftRefresh2 = true;
  tft.fillScreen(TFT_TRANSPARENT);
  drawButtons(BUTTON_CORNER_2_X, BUTTON_CORNER_2_Y);
  drawFirstButtons(BUTTON_FIRST_RAW_2_X, BUTTON_FIRST_RAW_2_Y);
  RefreshAllButtons_2() ;
}  //  END doAccessories

void doDCCaccessory() { 
  Serial.print ("<a ");
  Serial.print ((( AccessoryAddress - 1 ) / 4) + 1 ); // Accessory Address, DCC++ works with address + sub address
  Serial.print (" ");
  Serial.print (( AccessoryAddress - 1 ) % 4 );  // Accessory Sub Address 
  if (AccessoryAddressDble % 2 == 0 ) {      
    Serial.println (" 1 >");
  }
  else {
    Serial.println (" 0 >");
  }
}    //  END doDCCaccessory

int z = 0;
int powerTemp = 0;
// int i = 0;

struct LocoStructure {
  unsigned long magic;
  byte struct_version;
  uint16_t checksum;
  int address1; // adresse de la loco 1
  int address2; // adresse de la loco 2
  int address3; // adresse de la loco 3
  int address4; // adresse de la loco 4
};
struct LocoStructure ms {123456789, 4, 0, 8, 36,  12, 68 } ;

void plotDial(int16_t x, int16_t y, int16_t angle, String label, uint16_t val, String way) {
  // Draw the blank dial in the Sprite, add label and number
  drawEmptyDial(label, val, way);
  // Push a rotated needle Sprite to the dial Sprite, with black as transparent colour
  needle.pushRotated(&dial, angle, TFT_BLACK); // dial is the destination Sprite
  // Push the resultant dial Sprite to the screen, with transparent colour
  dial.pushSprite(x, y, TFT_TRANSPARENT);
}

void RefreshAllButtons_2() {  //   buttonsRefresh2 = true;  
    for (int k=0; k<5;  k++ ){ 
    if (bitRead(LocoFN0to4_2[ActiveAddress_2],  k) == 0 ) {updateFirstButtons(BUTTON_FIRST_RAW_2_X, BUTTON_FIRST_RAW_2_Y, k, TFT_MAROON);}
    else {updateFirstButtons(BUTTON_FIRST_RAW_2_X, BUTTON_FIRST_RAW_2_Y, k, TFT_RED);  }
   }
 // 3 group UPDATE BUTTONS FOR EACH CHANGE OF LOCO # LEFT
   for (int i=0; i<8; i++){ // 8 bits
    if (bitRead(LocoFN5to8_2[ActiveAddress_2], i) == 0 ) { updateButtons(BUTTON_CORNER_2_X, BUTTON_CORNER_2_Y, 0, i, TFT_MAROON);  }  // group of function , key
    else { updateButtons(BUTTON_CORNER_2_X, BUTTON_CORNER_2_Y, 0, i, TFT_RED); } // group , key
    if (bitRead(LocoFN13to20_2[ActiveAddress_2], i) == 0 ) { updateButtons(BUTTON_CORNER_2_X, BUTTON_CORNER_2_Y, 1, i, TFT_MAROON);  }  // group of function , key
    else { updateButtons(BUTTON_CORNER_2_X, BUTTON_CORNER_2_Y, 1, i, TFT_RED); } // group , key
    if (bitRead(LocoFN21to28_2[ActiveAddress_2], i) == 0 ) { updateButtons(BUTTON_CORNER_2_X, BUTTON_CORNER_2_Y, 2, i, TFT_MAROON);  }  // group of function , key
    else { updateButtons(BUTTON_CORNER_2_X, BUTTON_CORNER_2_Y, 2, i, TFT_RED); } // group , key
   }
  tft.setTextSize(1);
  tft.setTextFont(4);
  for (int k=1; k <= 3;  k++ ){  
    tft.setCursor(BUTTON_CORNER_2_X - 20, BUTTON_CORNER_2_Y - 30 + (20 * k));
    if (k == group_2[ActiveAddress_2]) {tft.setTextColor(TFT_CYAN,TFT_TRANSPARENT);} else {tft.setTextColor(TFT_TRANSPARENT,TFT_TRANSPARENT);}
    tft.print("I");   //  
  }
}

// =======================================================================================
// Setup
// =======================================================================================
void setup()   {
  Serial.begin(115200); //
  delay(500);
  Serial.print("<1>");
  debouncer1.attach(26, INPUT_PULLUP ); // coder pcb e_pad_22
  debouncer1.interval(5); // interval in ms
  getAddresses();
  pinMode (V_Pin, INPUT);
  voltage = analogRead(V_Pin) ;
  Serial.print("Voltage : ");
  Serial.println(voltage * 0.00165);
  Serial.print("Version ");
  Serial.println(version);
  tft.init();
  tft.fillScreen(TFT_BLACK);  
  tft.setRotation(0);
  tft.setTextFont(4);
  tft.setTextColor(TFT_GREEN, TFT_BLACK);
  tft.setCursor(0,100);
  tft.print("  S_Dial  V. ");
  tft.println(version); 
  tft.print("  ");
  tft.println(V_Date);
  tft.println("");
  tft.print("Voltage : ");
  tft.println(voltage * 0.00175);
  debouncer1.update();
    int value = debouncer1.read();  
    tft.setCursor(0, 0);
  tft.setTextColor(TFT_WHITE);  
  tft.println(value);
  if ( ! debouncer1.read() ) {
    getNumberOfLocos();
  }
  delay(4000);
  // Enable the weak pull up resistors
  ESP32Encoder::useInternalWeakPullResistors=UP;
  // Attache pins for use as encoder pins
  encoder2.attachFullQuad(16, 4);  //  encoder2.attachHalfQuad(16, 4);
  tft.setRotation(0); 
  tft.fillScreen(TFT_TRANSPARENT);

  // Draw the  dial
  drawEmptyDial("LOCO", 123, forward);    // String ahead ;draw the centre of dial in the Sprite
  dial.pushSprite(0, 0); // (110, 0);push a copy of the dial to the screen so we can see it

  // Draw the buttons
//  drawButtons(BUTTON_CORNER_X, BUTTON_CORNER_Y);
  drawButtons(BUTTON_CORNER_2_X, BUTTON_CORNER_2_Y);
  // Draw the top buttons
//  drawFirstButtons(BUTTON_FIRST_RAW_X, BUTTON_FIRST_RAW_Y);
  drawFirstButtons(BUTTON_FIRST_RAW_2_X, BUTTON_FIRST_RAW_2_Y);
  
  tft.setTextFont(4);     // Select the orginal small GLCD font by using NULL or GLCD
  spr.setTextFont(4);  
  // Create the needle Sprite
  createNeedle();
  dial.setPivot(DIAL_CENTRE_2_X, DIAL_CENTRE_2_Y);
  // Reset needle position to 0
  plotNeedle(0, 0);
//  delay(1000);
} // END OF SETUP



// =======================================================================================
// Loop
// =======================================================================================
void loop() {
  key = keypad.getKey();
  if (key == 42) { // *
    all2ZeroSpeeed();
    getLocoAddress();
    saveAddresses();
    key = 0;
  }
  // ROUTINE USING ROTARY ENCODER FOR SPEED AND BUTTON ON IT FOR DIRECTION
  if (key == 65) {doAccessories(); }          // letter A only
  if (key == 66) {doPoints(); }               // letter B only
  if (key == 67) {doTurnTable(); }            // letter C only


//    Serial.println("loop "); 


// switch ( commandGroup ) {

switch (group_2[ActiveAddress_2]) { //  group functions  LOCO LEFT
  case 0:
  if (key >= 49  && key <= 53) {  // functions F0 - F4 LOCO LEFT 49-53 1 to 5
    if (bitRead(LocoFN0to4_2[ActiveAddress_2], key - 49 ) == 0 ) { // bit key - 53 
      bitWrite(LocoFN0to4_2[ActiveAddress_2],  key - 49, 1);
      updateFirstButtons(BUTTON_FIRST_RAW_2_X, BUTTON_FIRST_RAW_2_Y, key - 49 , TFT_RED); 
    }
    else {
      if (bitRead(LocoFN0to4_2[ActiveAddress_2],  key - 49) == 1 ) {
        bitWrite(LocoFN0to4_2[ActiveAddress_2],  key - 49, 0);
        updateFirstButtons(BUTTON_FIRST_RAW_2_X, BUTTON_FIRST_RAW_2_Y, key - 49 , TFT_MAROON);     
//        updateFirstButtons(BUTTON_FIRST_RAW_2_X, BUTTON_FIRST_RAW_2_Y, key - 48 , TFT_MAROON);     
//        updateFirstButtons(BUTTON_FIRST_RAW_2_X, BUTTON_FIRST_RAW_2_Y, key - 47 , TFT_MAROON);     
      }
    }      
    doDCCfunction(LocoAddress_2[ActiveAddress_2], "", LocoFN0to4_2[ActiveAddress_2]);
  } // END functions F0 - F4 LOCO LEFT
  break;                                                             // END functions F0 - F4 LOCO LEFT
  case 1:
  if (key >= 49  && key <= 56) {  // functions F5to8 LOCO LEFT 53-56 6-8  49-54 10-13
    if (bitRead(LocoFN5to8_2[ActiveAddress_2],  key - 49 ) == 0 ) {
      bitWrite(LocoFN5to8_2[ActiveAddress_2],   key - 49, 1);
      updateButtons(BUTTON_CORNER_2_X, BUTTON_CORNER_2_Y, 0, key - 49, TFT_RED);  // group , key
    }
    else {
      if (bitRead(LocoFN5to8_2[ActiveAddress_2],  key - 49) == 1 ) {
        bitWrite(LocoFN5to8_2[ActiveAddress_2],  key - 49, 0);
        updateButtons(BUTTON_CORNER_2_X, BUTTON_CORNER_2_Y, 0, key - 49, TFT_MAROON);  // group , key
      }
    }      
  byte fx;  
  fx = (LocoFN5to8_2[ActiveAddress_2] & 15) + 176 ; doDCCfunction(LocoAddress_2[ActiveAddress_2], "", fx);   //ok 5-8
  fx = (LocoFN5to8_2[ActiveAddress_2] >> 4) + 160 ; doDCCfunction(LocoAddress_2[ActiveAddress_2], "", fx ); // ok 9-12
  // F9 to 12 + 160 F5 to F8 + 176
  }
  break;    
  case 2: // functions F13to20 LOCO LEFT  1 - 8 49 - 53
   if (key >= 49  && key <= 56) {   
    if (bitRead(LocoFN13to20_2[ActiveAddress_2],  key - 49) == 0 ) {
      bitWrite(LocoFN13to20_2[ActiveAddress_2], key - 49, 1);
      updateButtons(BUTTON_CORNER_2_X, BUTTON_CORNER_2_Y, 1, key - 49, TFT_RED);  // group , key
    }
    else {
      if (bitRead(LocoFN13to20_2[ActiveAddress_2], key - 49) == 1 ) {
        bitWrite(LocoFN13to20_2[ActiveAddress_2], key - 49, 0);
        updateButtons(BUTTON_CORNER_2_X, BUTTON_CORNER_2_Y, 1, key - 49, TFT_MAROON);  // group , key
      }
    }
  doDCCfunction(LocoAddress_2[ActiveAddress_2], " 222", LocoFN13to20_2[ActiveAddress_2]); 
  }    // END functions F13to20 LOCO LEFT
  break;  
  case 3: // 21to28
  if (key >= 49  && key <= 56) {   //  functions F21to28 LOCO LEFT 1 - 8 49 - 56
    if (bitRead(LocoFN21to28_2[ActiveAddress_2], key - 49) == 0 ) {
      bitWrite(LocoFN21to28_2[ActiveAddress_2], key - 49, 1);
      updateButtons(BUTTON_CORNER_2_X, BUTTON_CORNER_2_Y, 2, key - 49, TFT_RED);  // group , key
    }
    else {
      if (bitRead(LocoFN21to28_2[ActiveAddress_2], key - 49) == 1 ) {
        bitWrite(LocoFN21to28_2[ActiveAddress_2], key - 49, 0);
        updateButtons(BUTTON_CORNER_2_X, BUTTON_CORNER_2_Y, 2, key - 49, TFT_MAROON);  // group , key
      }
    }
  doDCCfunction(LocoAddress_2[ActiveAddress_2], " 223", LocoFN21to28_2[ActiveAddress_2]);
}    // END functions F21to28 LOCO LEFT
  break;
}  // END switch functions LOCO LEFT

  debouncer1.update();
  int value1 = debouncer1.read();
  if ( debouncer1.fell() ) {     // Toggle sens state LOCO LEFT
      sens2 = !sens2; // Toggle sens state :  
      if (sens2 == true){ arrow2 = forward; } else { arrow2 = backwards; }
      tftRefresh2 = true;
  }
  if (key == 35) { // #  CHANGE FUNCTION
    ActiveAddress_2++ ; if (ActiveAddress_2 > maxLocos_2 -1 ) {ActiveAddress_2 = 0;} // circle ActiveAddress_2 0 - 3
    tft.setTextColor(TFT_YELLOW,TFT_TRANSPARENT);tft.setCursor(210, 200);tft.print(ActiveAddress_2); //210, 230  210, 200
    encoder2.setCount( LocoSpeed_2[ActiveAddress_2]*3 );
    sens2 = LocoDirection_2[ActiveAddress_2];
    tftRefresh2 = true;
    RefreshAllButtons_2() ;
  }
//  CHANGE FUNCTION  groupActiveAddress LEFT
  if (key == 68) {   // letter D only    if ( debouncer8.fell() ) {
    group_2[ActiveAddress_2]++ ; if (group_2[ActiveAddress_2] > 3) {group_2[ActiveAddress_2] = 0;} // circle function group_2  0 - 3
    tft.setTextColor(TFT_WHITE,TFT_TRANSPARENT);tft.setCursor(210, 230);tft.print(group_2[ActiveAddress_2]); //210, 200
    RefreshAllButtons_2();
  }  
 
  if ((encoder2.getCount() != angle2 + 165 ) || tftRefresh2 ){
    angle2 = encoder2.getCount() - 165 ;
    if (angle2 < -165 ) {encoder2.setCount(0);} if (angle2 > 135 ) {encoder2.setCount(300);}
    memset (text, 0, sizeof(text));
    snprintf(text, sizeof(text)-1, "%d", LocoAddress_2[ActiveAddress_2]);
    plotDial(0, 0, angle2, text, (angle2 + 165) /3, arrow2);   // (angle1 + 165) /3); "LOCO2"
    tftRefresh2 = false;
    LocoSpeed_2[ActiveAddress_2] = (angle2 + 165) /3;
    LocoDirection_2[ActiveAddress_2] = sens2;  
    doDCC_2(ActiveAddress_2);   
  }

}
// end loop

// =======================================================================================
